package handler

import (
	"context"
	"net/http"

	httpsrv "go.unistack.org/micro-server-http/v3"
	"go.unistack.org/pkgdash/internal/models"
	pb "go.unistack.org/pkgdash/proto"
)

func (h *Handler) CommentList(ctx context.Context, req *pb.CommentListReq, rsp *pb.CommentListRsp) error {
	h.logger.Debug(ctx, "Start GetModule")

	err := req.Validate()
	if err != nil {
		h.logger.Error(ctx, "validate error", err)
		httpsrv.SetRspCode(ctx, http.StatusBadRequest)
		return httpsrv.SetError(NewValidationError(err))
	}

	comments, err := h.store.CommentList(ctx, req)
	if err != nil {
		h.logger.Error(ctx, "comment list error", err)
		httpsrv.SetRspCode(ctx, http.StatusInternalServerError)
		return httpsrv.SetError(NewInternalError(err))
	}

	for _, com := range comments {
		rsp.Comments = append(rsp.Comments, models.NewComment(com))
	}

	h.logger.Debug(ctx, "Success finish getModule")
	return nil
}
